image: node:12

cache:
  paths:
    - node_modules/

stages:
  - test
  - deploy

yarn_test_and_coveralls:
  stage: test
  variables:
    COVERALLS_SERVICE_NAME: gitlab-ci
  script:
    - yarn
    - COVERALLS_REPO_TOKEN=${COVERALLS_REPO_TOKEN} yarn test

yarn_check_for_version_bump:
  stage: test
  variables:
    GIT_FETCH_EXTRA_FLAGS: ${CI_DEFAULT_BRANCH}
  except:
    - trunk
  script:
    - yarn
    - yarn check-for-version-bump

publish_npm:
  stage: deploy
  only:
    - trunk
  script:
    - echo "//registry.npmjs.org/:_authToken=\${NPM_PUBLISH_TOKEN}" > .npmrc
    - echo "Created .npmrc:"
    - cat .npmrc
    - yarn build:ts
    - npm publish
    - rm .npmrc
